#include <windows.h>
#include <stdio.h>
#include <tchar.h>
#include <ctype.h>

#ifdef UNICODE
__declspec(dllimport) BOOL WINAPI InjectCommandW(HWND hwnd, LPWSTR lpCommand);
__declspec(dllimport) BOOL WINAPI InjectMessageW(HWND hwnd, LPWSTR lpMessage);
#define InjectCommand InjectCommandW
#define InjectMessage InjectMessageW
#else
__declspec(dllimport) BOOL WINAPI InjectCommandA(HWND hwnd, LPSTR lpCommand);
__declspec(dllimport) BOOL WINAPI InjectMessageA(HWND hwnd, LPSTR lpMessage);
#define InjectCommand InjectCommandA
#define InjectMessage InjectMessageA
#endif
__declspec(dllimport) BOOL WINAPI InjectKey(HWND hwnd, int nKey);
__declspec(dllimport) BOOL WINAPI InstallInjectEnvHook(void);
__declspec(dllimport) BOOL WINAPI UninstallInjectEnvHook(void);

typedef void (*FUNC)(HWND hwnd, LPTSTR arg);

typedef struct Table
{
	LPTSTR szCommand;
	int nLen;
	FUNC f;
} Table;

void SuspendMessageWindow(HWND hwnd, LPTSTR arg);
void ResumeMessageWindow(HWND hwnd, LPTSTR arg);
void AddMessage(HWND hwnd, LPTSTR arg);

Table tDispatch[] = {
	{ TEXT("SUSM"), 4, SuspendMessageWindow },
	{ TEXT("RESM"), 4, ResumeMessageWindow },
	{ TEXT("MES"), 3, AddMessage },
	{ NULL, 0, NULL }
};

#ifdef UNICODE
const TCHAR APPNAME[] = TEXT("afxscriptw.exe");
#else
const TCHAR APPNAME[] = TEXT("afxscript.exe");
#endif

LPTSTR GetClipboardText(void)
{
	LPTSTR buf = NULL;
	OpenClipboard(NULL);
#ifdef UNICODE
	HANDLE hText = GetClipboardData(CF_UNICODETEXT);
#else
	HANDLE hText = GetClipboardData(CF_TEXT);
#endif
	if(hText) {
		unsigned int size = GlobalSize(hText);
		buf = malloc(size);
		CopyMemory(buf, GlobalLock(hText), size);
		GlobalUnlock(hText);
#ifdef CONSOLE
		printf("%s\n%d %d\n", buf, size, lstrlen(buf));
#endif
	}
	CloseClipboard();
	return buf;
}

BOOL CALLBACK FindMessageWindow(HWND hwnd, LPARAM lParam)
{
	TCHAR buf[2048];
	GetClassName(hwnd, buf, sizeof(buf));
//	OutputDebugString(buf);
	if(!lstrcmp(buf, TEXT("TScrollBox"))) {
		HWND hwndParent = GetParent(hwnd);
		GetClassName(hwndParent, buf, sizeof(buf));
		OutputDebugString(buf);
		if(!lstrcmp(buf, TEXT("TPanel"))) {
			OutputDebugString(TEXT("Found"));
			HWND* pResult = (HWND*)lParam;
			*pResult = hwnd;
			return FALSE;
		}
	}
	return TRUE;
}

HWND GetMessageWindow(HWND hwnd)
{
	HWND hMesWin = NULL;
	EnumChildWindows(hwnd, FindMessageWindow, (LPARAM)&hMesWin);
	return hMesWin;
}

void SuspendMessageWindow(HWND hwnd, LPTSTR arg)
{
	HWND hwndTarget = GetMessageWindow(hwnd);
	if(hwndTarget) {
		SendMessage(hwndTarget, WM_SETREDRAW, FALSE, 0);
		OutputDebugString(TEXT("SuspendMessageWindow"));
	}
}

void ResumeMessageWindow(HWND hwnd, LPTSTR arg)
{
	HWND hwndTarget = GetMessageWindow(hwnd);
	if(hwndTarget) {
		SendMessage(hwndTarget, WM_SETREDRAW, TRUE, 0);
		InvalidateRect(hwndTarget, NULL, TRUE);
		OutputDebugString(TEXT("ResumeMessageWindow"));
	}
}

void AddMessage(HWND hwnd, LPTSTR arg)
{
#ifdef UNICODE
	while(*arg && _istspace(*arg)) arg++;
#else
	while(*arg && isspace((unsigned char)*arg)) arg++;
#endif
	TCHAR buf[2048];
	wsprintf(buf, TEXT("&CLIP %s"), arg);
	InjectCommand(hwnd, buf);
	LPTSTR mes = GetClipboardText();
	if(mes) InjectMessage(hwnd, mes);
	free(mes);
}

void ProcessInternalCommand(HWND hwnd, LPTSTR line)
{
	Table *ptEntry = tDispatch;
	while(ptEntry->szCommand) {
		if(!_tcsncmp(ptEntry->szCommand, line, ptEntry->nLen)) {
			ptEntry->f(hwnd, line + ptEntry->nLen);
			break;
		}
		++ptEntry;
	}
	if(!ptEntry->szCommand) {
		MessageBox(NULL, TEXT("FłȂR}h܂"), APPNAME, MB_OK);
		UninstallInjectEnvHook();
		exit(1);
	}
}

int main(int argc, char **argv)
{
	HWND hwnd;
	FILE *fp;

	if(argc != 2) {
		TCHAR buf[2048];
		wsprintf(buf, TEXT("gp@F%s <XNvgt@C>"), APPNAME);
		MessageBox(NULL, buf, APPNAME, MB_OK);
		return 1;
	}

	fp = fopen(argv[1], "rb");
	if(!fp) {
		MessageBox(NULL, TEXT("t@CJ܂"), APPNAME, MB_OK);
		return 2;
	}

#ifdef UNICODE
	hwnd = FindWindow(TEXT("TAfxWForm"), NULL);
	if(!hwnd) {
		hwnd = FindWindow(TEXT("TAfxForm"), NULL);
	}
#else
	hwnd = FindWindow(TEXT("TAfxForm"), NULL);
	if(!hwnd) {
		hwnd = FindWindow(TEXT("TAfxWForm"), NULL);
	}
#endif
	if(hwnd) {
		TCHAR buf_[2048];
		InstallInjectEnvHook();
		while(_fgetts(buf_, sizeof(buf_), fp)) {
			LPTSTR buf = buf_, temp;
			int key;
			for(temp = buf; *temp != 0; ++temp) {
				if(*temp == TEXT('\r') || *temp == TEXT('\n')) {
					*temp = TEXT('\0');
					break;
				}
			}
#ifdef UNICODE
			if(*buf == 0xFEFF) ++buf;
#endif
			switch(*buf) {
			case TEXT('#'):
				key = _ttoi(buf+1);
				if(key >= 0 && key < 8000) InjectKey(hwnd, key);
				break;
			case TEXT(';'):
				break;
			case TEXT('%'):
				ProcessInternalCommand(hwnd, buf + 1);
				break;
			default:
				InjectCommand(hwnd, buf);
			}
		}
		UninstallInjectEnvHook();
	} else {
		MessageBox(NULL, TEXT("ӂ̃EBhE܂"), APPNAME, MB_OK);
	}

	fclose(fp);

	return 0;
}
